import IRC.*;
import org.omg.CORBA.*;
import org.omg.CosNaming.*;
import org.omg.PortableServer.POA;
import java.net.InetAddress;

public class ServerInitPOA {
	

	public static void main(String[] args) {
		try {
			// Inicialitzem la referencia al ORB
			ORB myORB = ORB.init(args, null);

			// Creem una instancia del servidor de xat
			ServerPOA xat = new ServerPOA();

			// Obtenim l'arrel del POA (Portable Object Adapter)
			POA rootPOA = (POA) myORB.resolve_initial_references("RootPOA");
			// Activem el gestor POA
			rootPOA.the_POAManager().activate();
			// Activem el nostre servant, aix peticions directes amb corbaloc
			// o IOR URL funcionaran inmediatament.
			rootPOA.activate_object(xat);

			// Obtenim la referencia al objecte
			org.omg.CORBA.Object obj = rootPOA.servant_to_reference(xat);
			IServer xatRef = (IServer) IServerHelper.narrow(obj);

			// Obtenim el context arrel del servei de noms
			org.omg.CORBA.Object objRef = myORB.resolve_initial_references("NameService");
			NamingContextExt nc = NamingContextExtHelper.narrow(objRef);

			// Registrem l'objecte local al servei de noms.
			NameComponent[] name = nc.to_name("Xat");
			nc.rebind(name, xatRef);

			// Imprimim per pantalla les diferens URLs amb les que es pot accedir
			// al servidor.
			System.out.println("Servidor registrat amb el nom: Xat");
			System.out.println("URLs: ");
			// Obtenim IOR
			System.out.println("\nIOR");
			System.out.println("\t" + myORB.object_to_string(xatRef));
			// Obtenim corbaloc URL
			System.out.println("\ncorbaloc");
			System.out.println(
				"\tcorbaloc:iiop:" + InetAddress.getLocalHost().getHostName());
			System.out.println("\ncorbaname");
			// Obtenim el corbaname URL
			System.out.println("\tcorbaname:iiop:"+ InetAddress.getLocalHost().getHostName()
					+ "#Xat");

			// Esperar clients que es connectin
			myORB.run();
		} catch (Exception e) {
			System.out.println("Error!!");
			e.printStackTrace();
    }
  }
}
