import IRC.*;
import org.omg.CORBA.*;
import org.omg.CORBA.ORBPackage.*;
import org.omg.CosNaming.*;
import java.util.*;
import java.io.*;

import org.omg.PortableServer.POA;
import java.net.InetAddress;

public class XatClient {
	
	public static void main(String args[]) {
		// Inicialitzem l'ORB
		ORB orb = ORB.init(args, null);
		org.omg.CORBA.Object ref = null;
		
		// Nom de l'objecte remot, pot ser un nom a buscar al servei de nom
		// o una URL.
		String name = args[0];
		IServer xat = null;
		
		// Si ens han passat una URL o referencia "stringficada"
		if (name.startsWith("corbaname") || name.startsWith("corbaloc") || name.startsWith("IOR")) {
			System.out.println("Intentant accedir a... " + args[0]);
			ref = orb.string_to_object(args[0]);
			xat = IServerHelper.narrow(ref);
		} else {
			// Ens han passat un nom, buscar al Naming Service.
			try {
				ref = orb.resolve_initial_references("NameService");
			} catch (InvalidName invN) {
				System.out.println("Couldn't locate a Naming Service");
				System.exit(1);
			}
			NamingContext nameContext = NamingContextHelper.narrow(ref);
			NameComponent comp = new NameComponent(args[0], "");
			NameComponent path[] = {comp};
			try {
				ref = nameContext.resolve(path);
				System.out.println("ref = " + ref);
				xat = IServerHelper.narrow(ref);
			} catch (Exception e) {
				System.out.println("Error buscan nom al Naming Service");
				e.printStackTrace();
			}
		}

		// Si hem aconseguit trobar l'objecte remot
		if (xat != null) {
			try {
				System.out.println("Objecte remot trobat.");
				
				BufferedReader console = new BufferedReader(new InputStreamReader(System.in));
				
				// Dades de connexi
				System.out.print("Nick: ");
				String nick = console.readLine();
				ControlPOA ctrl = new ControlPOA(nick);
				
				// ctrl sera passat per referencia, cal activar-ho com objecte remot
				
				// Obtenim el POA (Portable Object Adapter)
				POA rootPOA = (POA) orb.resolve_initial_references("RootPOA");
				// Activem el gestor POA
				rootPOA.the_POAManager().activate();
				// Activem el nostre servant, aix peticions directes amb corbaloc
				// o IOR URL funcionaran inmediatament.
				rootPOA.activate_object(ctrl);
	
				// Obtenim la referencia al objecte
				org.omg.CORBA.Object obj = rootPOA.servant_to_reference(ctrl);
				IControl ctrlRef = (IControl) IControlHelper.narrow(obj);
				
				// Conectem al xat
				xat.Connectar(ctrlRef);

				String text = console.readLine();
				while (text.compareTo("/quit") != 0) {
					
					if (text.compareTo("/users") == 0) {
						String userList[] = xat.Usuaris();
						System.out.println("-- Users --");
						for (int i=0; i<userList.length; i++) {
							System.out.println(userList[i]);
						}
						System.out.println("-- End --");
					} else {
						xat.Enviar(ctrlRef, text);
					}
					
					text = console.readLine();
				}
				
				System.out.println("Exiting...");
				xat.Desconnectar(ctrlRef);
			} catch (Exception e) {
				e.printStackTrace();
			}

		} else {
			System.out.println("Objecte remot no trobat.");
			System.exit(1);
		}
	}
}
